# Diogenes

*"The most beautiful thing in the world is freedom of speech."* --Diogenes

Diogenes (412 BC - 323 BC, not to be confused with the other Diogenes that recorded his life) was one of the biggest, most significant ancient Greek [philosophers](philosophy.md), the best known proponent of [Cynicism](cynicism.md) and one of the absolutely most [based](based.md) men in [history](history.md) as by his philosophy he practiced extreme life [minimalism](minimalism.md) (he lived in a barrel), [asceticism](asceticism.md), self-sufficiency, nonconformism, he refused to [work](work.md), [refused all authority](anarchism.md), criticized absolutely everything and was always extremely [logically](logic.md) consistent and behaved in accordance to what he taught, which is really what makes all his critics -- mostly just big [hypocrite](hypocrisy.md) pussies -- so greatly pissed; the philosophy of Diogenes is quite close to [our own ideals](less_retarded_society.md). The word "cynic" itself comes from a word for "[dog](dog.md)" and indeed, Diogenes lived as one, he just roamed the streets barefoot with a stick, he wore a robe that at night he used to cover himself ([two in one](two_in_one.md)), he didn't give a [shit](shit.md) about anything, preached his [wisdom](wisdom.md), he basically didn't own anything as he believed possession only enslaves us and that everything we need is already there in the nature. He didn't seek [popularity](hero_culture.md), approval, wealth or power, he desired [freedom](freedom.md), spiritual and moral purity, he wanted to let go of absolutely all [bullshit](bullshit.md). The man was also pretty [funny](fun.md), reading about him is really on the level of [4chan](4chan.md) humor, more than 2000 years ahead of his time -- Socrates, Plato and Aristotle wrote pages and pages of boring, serious as fuck walls of text; Diogenes overshadowed them all just with a third party record of his existence. Diogenes wrote some stuff, most famously his *Republic* describing an ideal society, however none of his writings sadly survived, we now only know what others have written about him (there are possibly some recounts of the works who have read them). Let's remember we shouldn't call him a [hero](hero_culture.md), that would itself contradict both his and our philosophy, but if we are to see anyone as a good inspiration and moral example, Diogenes is among the best (well, at least in most things, it goes without saying we can't absolutely embrace everything someone ever did).

Some famous and/or [interesting](interesting.md) things he did (or at 
least is said to have done):

- He lived in a barrel with his only possession being a bowl which he later threw away because a boy showed him he could actually drink using just bare hands ("A child has beaten me at simple living!").
- He didn't [work](work.md), just begged.
- Most of all he despised [greed](capitalism.md) and lust for profit.
- He walked with a lantern in crowds of people, saying he was "looking for a man". By this he implied all those around [weren't even worthy](npc.md) of being called *people*. { There seems to be a widespread inaccuracy in translations that say he was looking for "honest man", but apparently he just said "man", i.e. literally just human being. ~drummyfish }
- He masturbated in public. When asked why, he replied: "If only I could satisfy hunger by rubbing my belly!" { Based. ~drummyfish } He seems to have done it just to get rid of the physiological need, for example when a prostitute promised to visit him but came late, he already did the job himself.
- When asked where he was from, he always answered "I am citizen of the world", using the word [cosmopolitan](cosmopolitan.md) (he's credited for coining it). By this he gave a huge fuck you to [nationalism](nationalism.md).
- He just shat, pissed and farted wherever he wanted, he was stealing without shame, he would eat where it was forbidden to eat, e.g. in Plato's lectures. He also didn't restrain from always saying what he was thinking, he did zero self [censorship](censorship.md).
- As he became quite famous, Alexander the Great himself (the biggest boss in the world at the time) came to meet him and asked if he could do anything for him, Diogenes just replied "yeah, get out of my sunlight". It impressed even Alexander who allegedly said "If I weren't Alexander, I would be Diogenes". Another of their dialogue went like this:  Alexander: "Are you not afraid of me?", Diogenes: "Why? Are you good or bad?", Alexander: "I am good!", Diogenes: "Well then, who is afradid of the good?".
- Being asked what the most [beuatiful](beauty.md) thing in the world was, he replied "[freedom of speech](free_speech.md)". { Sauce: the book *Lives of the Eminent Philosophers*. ~drummyfish }
- As he was dying he said after death he just wanted to be thrown to animals to be eaten. { I'm thinking of actually writing this in my will. ~drummyfish }
- When asked why he was begging when Plato wasn't, he said "He is too, he just holds his head down so it can't be heard."
- Once he was invited to a dinner, he said he wouldn't go because "last time he went, the host didn't show proper gratitude."
- At seeing temple police arresting a thief he exclaimed "look, big thieves are arresting a small thief".
- [LULZ](lulz.md) (not embraced but funny): Once he was asking some man for fruit, the man said "I'll give it to you if you can persuade me". Diogenes said: "If I could persuade you, I would persuade you to [hang yourself](kys.md)".
- ...

**His [life](life.md) in short summary**: he was born probably 412 (or 419?) BC in Sinope (Turkey) to Hicesius, a [money](money.md) changer, then he got into trouble for devaluing currency with his father so he left the city and soon found himself in Athens where he went on to become the pupil of Antisthenes. He began to live in a tub belonging to the temple of Cybele. He hated Plato's philosophy of [idealism](idealism.md), called it [shite](shit.md) and disrupted his lectures on purpose e.g. by eating there or asking weird questions -- he also had some funny conversations and [troll](trolling.md) moments with him, like when he offered him some figs and when Plato ate them, Diogenes was like "Bruh, I thought you would share them, not eat them all". Plato called him "Socrates gone mad". Diogenes advised both mental and physical practice -- training the mind is obviously important for achieving inner freedom and wisdom, but body and mind are interconnected, asceticism leads to learning to live with little, not be [dependent](dependency.md) on much and frees us from slavery and unnecessary desire. He said that not needing anything was the privilege of gods, but a man could get close to gods by needing only [very little](minimalism.md). When traveling to Aegina he was captured by pirates and sold as a slave to Xeniades, a man living in Corinth. Being a greatly educated slave, Xeniades actually made Diogenes a teacher of his two sons, and Diogenes didn't live such a bad life, he could still preach his philosophy and indeed he did, until he died in 323 BC -- it is said he died on the same day as Alexander the Great. It's been recorded at the day of his death he just seated himself on the road to Olympia and calmly passed away. A pillar with marble dog was erected in his honor.

**Why was he so [based](based.md) you ask?** Most normies don't get this, they are like ["shit in public = bad"](shortcut_thinking.md) or "no werk = steal" etc., it just shows how immensely retarded everyone is (and why Diogenes really couldn't find a man anywhere, he really just saw monkeys). Diogenes was the only one around who was ACTUALLY THINKING, he wouldn't accept any word of a propaganda without first thinking about if those words were actually true. He saw something and asked "is it good?". And he came to conclusion that most things are just [bullshit](bloat.md). But that's not all: not only did he say something was bullshit -- something most people would just go on doing without end -- he actually just stopped doing the bullshit and by that proved his point. Majority of ordinary people hated (and still hate) him because he just clearly proves them wrong, without any shadow of a doubt, plainly by demonstrating something is unnecessary by living without it. Politicians in suits are just idiotic talking retardheads in expensive suits who will only talk talk talk talk and lie and preach huge bullshit without actually doing anything and if someone just clearly shows they are idiots, their only possible "defense" is to discredit the opposition, which is why all the idiots just try to spread hate of Diogenes (and ad hominem of his teaching) based on shallow things like "the guy shit in public + his cloth smells = bad = words false" (but ofc it's actually effective on the population made basically of zombies). Diogenes didn't even have to talk much, he just said "this is bullcrap, look, you can live without it", and then he JUST DID IT like the biggest chad.

From the times of antiquity also come more funny stories, for instance about Hippocrates and Democritus: Hippocrates was sent to cure Democritus who was just laughing uncontrollably at everyone and looked insane; Hippocrates talked to him and Democritus explained he is just laughing at all the [retards](retard.md) who keep chasing [bullshit](bullshit.md) in life, he exaplained people are worse than animals and extremely stupid, to which Hippocrates had nothing to say, he thanked him for the wisdom and told the people the man is just very wise and there is nothing to cure.

## See Also

- [cynicism](cynicism.md)
- [Buddha](buddha.md)
- [Jesus](jesus.md)
- [Pythagoras](pythagoras.md)
